var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;

var VID_MATE_YTB_FORMAT = [
	{ itag: 5, width: 320, height: 240, format: "FLV", acodec: "MP3", vcodec: "H.263", quality: "240p", title: "320x240(FLV 240p)", canList: false },
	{ itag: 17, width: 176, height: 144, format: "3GP", acodec: "AAC", vcodec: "MPEG-4", quality: "144p", title: "176x144(3GP 144p)", canList: true },
    { itag: 18, width: 640, height: 360, format: "MP4", acodec: "AAC", vcodec: "MPEG-4", quality: "360p", title: "640x360(MP4 360p)", canList: true },
    { itag: 22, width: 1280, height: 720, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "720p", title: "1280x720(MP4 720p)", canList: true },
    { itag: 34, width: 640, height: 360, format: "FLV", acodec: "AAC", vcodec: "H.264", quality: "360p", title: "640x360(FLV 360p)", canList: true },
    { itag: 35, width: 854, height: 480, format: "FLV", acodec: "AAC", vcodec: "H.264", quality: "480p", title: "854x480(FLV 480p)", canList: true },
    { itag: 36, width: 320, height: 240, format: "3GP", acodec: "AAC", vcodec: "MPEG-4", quality: "240p", title: "320x240(3GP 240p)", canList: true },
    { itag: 37, width: 1920, height: 1080, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "1080p", title: "1920x1080(MP4 1080p)", canList: true },
    { itag: 38, width: 2048, height: 1536, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "4K", title: "2048x1536(MP4 4K)", canList: true },
    { itag: 43, width: 640, height: 360, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "360p", title: "640x360(WEBM 360p)", canList: true },
    { itag: 44, width: 854, height: 480, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "480p", title: "854x480(WEBM 480p)", canList: true },
    { itag: 45, width: 1280, height: 720, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "720p", title: "1280x720(WEBM 720p)", canList: true },
    { itag: 46, width: 1920, height: 1080, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "1080p", title: "1920x1080(WEBM 1080p)", canList: true },
    { itag: 82, width: 640, height: 360, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "360p", title: "640x360(MP4 360p)", canList: true },
    { itag: 83, width: 854, height: 480, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "480p", title: "854x480(MP4 480p)", canList: true },
    { itag: 84, width: 1280, height: 720, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "720p", title: "1280x720(MP4 720p)", canList: true },
    { itag: 85, width: 1920, height: 1080, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "1080p", title: "1920x1080(MP4 1080p)", canList: true },
    { itag: 100, width: 640, height: 360, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "360p", title: "640x360(WEBM 360p)", canList: true },
    { itag: 101, width: 854, height: 480, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "480p", title: "854x480(WEBM 480p)", canList: true },
    { itag: 102, width: 1280, height: 720, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "720p", title: "1280x720(WEBM 720p)", canList: true },
    { itag: 133, width: 320, height: 240, format: "MP4", acodec: "", vcodec: "H.264", quality: "240p", title: "320x240(MP4 240p)", canList: false },
    { itag: 134, width: 640, height: 360, format: "MP4", acodec: "", vcodec: "H.264", quality: "360p", title: "640x360(MP4 360p)", canList: false },
    { itag: 135, width: 854, height: 480, format: "MP4", acodec: "", vcodec: "H.264", quality: "480p", title: "854x480(MP4 480p)", canList: false },
    { itag: 136, width: 1280, height: 720, format: "MP4", acodec: "", vcodec: "H.264", quality: "720p", title: "1280x720(MP4 720p)", canList: false },
    { itag: 137, width: 1920, height: 1020, format: "MP4", acodec: "", vcodec: "H.264", quality: "1080p", title: "1920x1080(MP4 1080p)", canList: false },
    { itag: 138, width: 2048, height: 1536, format: "MP4", acodec: "", vcodec: "H.264", quality: "4K", title: "2048x1536(MP4 4K)", canList: false },
    { itag: 139, width: 0, height: 0, format: "M4A", acodec: "AAC", vcodec: "", quality: "48kbps", title: "M4A(AAC 48k)", canList: true },
    { itag: 140, width: 0, height: 0, format: "M4A", acodec: "AAC", vcodec: "", quality: "128kbps", title: "M4A(AAC 128k)", canList: true },
    { itag: 141, width: 0, height: 0, format: "M4A", acodec: "AAC", vcodec: "", quality: "256kbps", title: "M4A(AAC 256k)", canList: true },
    { itag: 160, width: 176, height: 144, format: "MP4", acodec: "", vcodec: "H.264", quality: "144p", title: "176x144(MP4 144p)", canList: false },
    { itag: 171, width: 0, height: 0, format: "WebM", acodec: "Vorbis", vcodec: "", quality: "128kbps", title: "WEBM(Vorbis 128k)", canList: false },
    { itag: 172, width: 0, height: 0, format: "WebM", acodec: "Vorbis", vcodec: "", quality: "256kbps", title: "WEBM(Vorbis 256k)", canList: false },
    { itag: 242, width: 320, height: 240, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "240p", title: "320x240(WEBM 240p)", canList: false },
    { itag: 243, width: 640, height: 360, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "360p", title: "640x360(WEBM 360p)", canList: false },
    { itag: 244, width: 854, height: 480, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "480p", title: "854x480(FLV 480p)", canList: false },
    { itag: 245, width: 854, height: 480, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "480p", title: "854x480(FLV 480p)", canList: false },
    { itag: 246, width: 854, height: 480, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "480p", title: "854x480(FLV 480p)", canList: false },
    { itag: 247, width: 1280, height: 720, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "720p", title: "1280x720(WEBM 720p)", canList: false },
    { itag: 248, width: 1920, height: 1080, format: "WebM", acodec: "Vorbis", vcodec: "VP8", quality: "1080p", title: "1920x1080(WEBM 1080p)", canList: false },
    { itag: 264, width: 1920, height: 1080, format: "MP4", acodec: "AAC", vcodec: "H.264", quality: "1080p", title: "1920x1080(MP4 1080p)", canList: false }
];

//for blank
var global_vid_mate_video_id = global_vid_mate_video_id || 99999;

function vid_mate_video_ytb_getFormat(itag)
{
    for (var i = 0; i < VID_MATE_YTB_FORMAT.length; i++)
	{
        if (VID_MATE_YTB_FORMAT[i].itag == itag)
		{
            return VID_MATE_YTB_FORMAT[i];
        }
    }
    return null;
}

function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}

	//http://m.vuclip.com/w?cid=820271929&l=18078480&bu=6346895593&frm=w&nvt=&z=34812
	if(-1 == vid_mate_url.indexOf("vuclip"))
	{
		return null;
	}
	
	var matched = (/m[0-9]{0,1}.vuclip.com/i);

	if(false ==  matched.test(vid_mate_url))
	{
		return null;
	}
	
	var cid = vid_mate_get_parameter(vid_mate_url, "cid");
	if(!cid)
	{
		return null;
	}

	return cid;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{

    url = document.URL;

    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	global_document_url = url;

	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info.. ....');

		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		//var userAgent = navigator.userAgent;
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('vuclip 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "vuclip";
	rtn_video.id = vid_mate_get_video_id(global_document_url);

	var video = cutstr(vm_content, "<video", "</video>");
	if(!video)
	{
		var ytb_id = cutstr(vm_content, "videoId: '", "'");
		if(!ytb_id)
		{
			vid_mate_error_default('get video url fail');
			return null;
		}
		else
		{	
			global_vid_mate_video_id = ytb_id;
			get_youtube_video_info(ytb_id);
			return;
		}
		
	}

	var VideoUrl = cutstr(video, "src=\"", "\"");
	var img = cutstr(video, "poster=\"", "\"");
	rtn_video.picture_default = img;
	rtn_video.picture_big = img;

	//title
	var tmp_re = new RegExp("<title>(.+?)</title>");
	if (tmp_re.test(vm_content))
	{
		var tmp_m = vm_content.match(tmp_re);
		var title = tmp_m[1];
		title = title.replace("- Vuclip", "");
		rtn_video.title = title;
	}

	if(VideoUrl)
	{
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = VideoUrl;
		var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
		tmp_video_file.format = tmp_format;
		tmp_video_file.title = tmp_format;
		tmp_video_file.f_id = rtn_video.id;
		rtn_video.files.push(tmp_video_file);
	}
	else
	{
		vid_mate_error_default('no video resource');
		return null;
	}
	
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function cutstr(content, prefix, suffix)
{
        var prefix_len = prefix.length;
        var p1 = content.indexOf(prefix);
        if(-1 == p1)
        {
                return "";
        }
        p1 += prefix_len;
        var p2 = content.indexOf(suffix, p1);
        if(-1 == p2)
        {
                return "";
        }
        return content.substring(p1, p2);
}

function get_youtube_video_info(ytb_id)
{
	var vid_mate_url_get = "http://www.youtube.com/get_video_info?video_id="+ytb_id+"&asv=3&el=detailpage&hl=en_US&sts=16230";
	
	try
	{
		var referer = vid_mate_url_get;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; U; Android 2.2; en-us; Droid Build/FRG22D) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0";
		window.vbrowser.httpBegin(vid_mate_url_get);
		window.vbrowser.httpSetHeader("Cookie", cookie);
		window.vbrowser.httpSetHeader("Referer", referer);
		window.vbrowser.httpSetHeader("User-Agent", userAgent);
		window.vbrowser.httpGet('vid_mate_xhr_result_www()');
	}
	catch (e)
	{
		vid_mate_error("vuclip:Network error, try it later!", 'youtube http get fail for www' + '\r\nurl:' + document.URL);
		return null;
	}
}	

function vid_mate_xhr_result_www()
{
    var vid_mate_response;
	try
	{
        vid_mate_response = window.vbrowser.getHttpRes();
    }
	catch (e)
	{
		vid_mate_error("vuclip: Network error, try it later!", 'youtube_xhr_result_www window.vbrowser.getHttpRes fail' + '\r\nurl:' + document.URL);
		return null;
	}

    if (vid_mate_response != null && vid_mate_response.length > 0)
	{
        vid_mate_youtube_video_analytics(vid_mate_response);
    }
	else
	{
		vid_mate_error("vuclip:Network error, try it later!", 'youtube_xhr_result_www vid_mate_response is empty' + '\r\nurl:' + document.URL);
		return null;
	}
}


function vid_mate_youtube_video_analytics(vm_content)
{
	vid_mate_setParseMsg(60, 90, 'Analytics Video Info..');
	var sign_flag = false;
	var content = vm_content || "";

	if(content && -1 != content.indexOf("url_encoded_fmt_stream_map"))
	{
		var videoTitle = "";
		var videoDuration = 0;
		var url_encoded_fmt_stream_map = "";
		var adaptive_fmts = "";

		var dataArray = content.split("&");
		for(var i=0; i<dataArray.length; ++i)
		{
			var obj = dataArray[i];
			var tmpArray = obj.split("=");
			if(2 != tmpArray.length)
			{
				continue;
			}

			tmpArray[1] = decodeURIComponent(tmpArray[1]);
			if("title" == tmpArray[0])
			{
				videoTitle = tmpArray[1];
			}
			else if("length_seconds" == tmpArray[0])
			{
				videoDuration = tmpArray[1];
			}
			else if("url_encoded_fmt_stream_map" == tmpArray[0])
			{
				url_encoded_fmt_stream_map = tmpArray[1];
			}
			else if("adaptive_fmts" == tmpArray[0])
			{
				adaptive_fmts = tmpArray[1];
			}
		}

		if(0 == url_encoded_fmt_stream_map.length && 0 == adaptive_fmts.length)
		{
			vid_mate_error_default('vuclip:url_encoded_fmt_stream_map and adaptive_fmts is empty');
			return null;
		}

		var rtn_video = new vid_mate_video();
		rtn_video.check_type = "vuclip";
		rtn_video.id = global_vid_mate_video_id;
		rtn_video.title = videoTitle;
		rtn_video.duration = videoDuration;
		rtn_video.url = global_document_url;
		rtn_video.js_ver  = "1.03";
		rtn_video.js_info = "20160328:delete domain";
		rtn_video.picture_default = 'http://i4.ytimg.com/vi/' + rtn_video.id + '/default.jpg';
		rtn_video.picture_big = 'http://i4.ytimg.com/vi/' + rtn_video.id + '/mqdefault.jpg';

		//url_encoded_fmt_stream_map
		if(url_encoded_fmt_stream_map.length > 0)
		{
			var arr = url_encoded_fmt_stream_map.split(",");
			for(var i=0; i<arr.length; ++i)
			{
				var arr1 = arr[i].split("&");

				var itag = "";
				var sign = "";
				var videoFileUrl = "";
				var videoTitle = "";
				for(var j=0; j<arr1.length; ++j)
				{
					var arr2 = arr1[j].split("=");
					if(2 != arr2.length)
					{
						continue;
					}

					if("itag" == arr2[0])
					{
						itag = arr2[1];
					}
					 else if("s" == arr2[0] || "signature" == arr2[0])
					{
						sign = arr2[1];
					}
					else if("url" == arr2[0])
					{
						videoFileUrl = decodeURIComponent(arr2[1]);
					}
				}

				var tmp_format = vid_mate_video_ytb_getFormat(itag);
				if (tmp_format != null && tmp_format.canList)
				{
					var tmp_video_file = new vid_mate_video_file();
					tmp_video_file.f_id = rtn_video.id + "_" + tmp_format.itag;
					tmp_video_file.format = tmp_format.format;
					tmp_video_file.width = tmp_format.width;
					tmp_video_file.height = tmp_format.height;
					tmp_video_file.quality = tmp_format.quality;
					tmp_video_file.title = tmp_format.title;
					if(-1 == videoFileUrl.indexOf('signature'))
					{
						videoFileUrl = videoFileUrl + "&signature=" + decodeSig(sign);
					}
					tmp_video_file.url = videoFileUrl;
					rtn_video.files.push(tmp_video_file);
				}
			}
		}

		//adaptive_fmts
		if(adaptive_fmts.length > 0)
		{
			var arr = adaptive_fmts.split(",");
			for(var i=0; i<arr.length; ++i)
			{
				var arr1 = arr[i].split("&");

				var itag = "";
				var sign = "";
				var videoFileUrl = "";
				var videoTitle = "";
				for(var j=0; j<arr1.length; ++j)
				{
					var arr2 = arr1[j].split("=");
					if(2 != arr2.length)
					{
						continue;
					}

					if("itag" == arr2[0])
					{
						itag = arr2[1];
					}
					else if("s" == arr2[0])
					{
						sign = arr2[1];
					}
					else if("url" == arr2[0])
					{
						videoFileUrl = decodeURIComponent(arr2[1]);
					}
				}

				var tmp_format = vid_mate_video_ytb_getFormat(itag);
				if (tmp_format != null && tmp_format.canList)
				{
					var tmp_video_file = new vid_mate_video_file();
					tmp_video_file.f_id = rtn_video.id + "_" + tmp_format.itag;
					tmp_video_file.format = tmp_format.format;
					tmp_video_file.width = tmp_format.width;
					tmp_video_file.height = tmp_format.height;
					tmp_video_file.quality = tmp_format.quality;
					tmp_video_file.title = tmp_format.title;
					//if(-1 == videoFileUrl.indexOf('signature'))
					//{
					//	videoFileUrl = videoFileUrl + "&signature=" + decodeSig(sign);
					//}
					tmp_video_file.url = videoFileUrl;
					rtn_video.files.push(tmp_video_file);
				}
			}
		}
		
		if(rtn_video.files.length >= 1)
		{
			vid_mate_setParseMsg(100, 100, 'Completed');
			vid_mate_set_videoInfo(JSON.stringify(rtn_video));
		}
	}
}